#include "bma.h"

// #define DEBUG
TwoWire *BMA::_bus = nullptr;
static uint8_t _dev_addr = BMA4_I2C_ADDR_PRIMARY;
const struct bma423_axes_remap remap_data={0,1,2,0,1,1}; 
/**\name Step counter parameter setting(1-25) for wrist (Default) */
// #define BMA423_WRIST_SC_PARAM_1   UINT16_C(0x12D)
// #define BMA423_WRIST_SC_PARAM_2   UINT16_C(0x7BD4)
// #define BMA423_WRIST_SC_PARAM_3   UINT16_C(0x13B)
// #define BMA423_WRIST_SC_PARAM_4   UINT16_C(0x7ADB)
// #define BMA423_WRIST_SC_PARAM_5   UINT8_C(0x04)
// #define BMA423_WRIST_SC_PARAM_6   UINT16_C(0x7B3F)
// #define BMA423_WRIST_SC_PARAM_7   UINT16_C(0x6CCD)
// #define BMA423_WRIST_SC_PARAM_8   UINT16_C(0x4C3)
// #define BMA423_WRIST_SC_PARAM_9   UINT16_C(0x985)
// #define BMA423_WRIST_SC_PARAM_10  UINT16_C(0x4C3)
// #define BMA423_WRIST_SC_PARAM_11  UINT16_C(0xE6EC)
// #define BMA423_WRIST_SC_PARAM_12  UINT16_C(0x460C)
// #define BMA423_WRIST_SC_PARAM_13  UINT8_C(0x01)
// #define BMA423_WRIST_SC_PARAM_14  UINT8_C(0x27)
// #define BMA423_WRIST_SC_PARAM_15  UINT8_C(0x19)
// #define BMA423_WRIST_SC_PARAM_16  UINT8_C(0x96)
// #define BMA423_WRIST_SC_PARAM_17  UINT8_C(0xA0)
// #define BMA423_WRIST_SC_PARAM_18  UINT8_C(0x01)
// #define BMA423_WRIST_SC_PARAM_19  UINT8_C(0x0C)
// #define BMA423_WRIST_SC_PARAM_20  UINT16_C(0x3CF0)
// #define BMA423_WRIST_SC_PARAM_21  UINT16_C(0x100)
// #define BMA423_WRIST_SC_PARAM_22  UINT8_C(0x01)
// #define BMA423_WRIST_SC_PARAM_23  UINT8_C(0x03)
// #define BMA423_WRIST_SC_PARAM_24  UINT8_C(0x01)
// #define BMA423_WRIST_SC_PARAM_25  UINT8_C(0x0E)
// const struct bma423_stepcounter_settings setting_wrist={BMA423_WRIST_SC_PARAM_1,BMA423_WRIST_SC_PARAM_2,BMA423_WRIST_SC_PARAM_3,BMA423_WRIST_SC_PARAM_4,BMA423_WRIST_SC_PARAM_5,BMA423_WRIST_SC_PARAM_6,
//                                             BMA423_WRIST_SC_PARAM_7,BMA423_WRIST_SC_PARAM_8,BMA423_WRIST_SC_PARAM_9,BMA423_WRIST_SC_PARAM_10,BMA423_WRIST_SC_PARAM_11,BMA423_WRIST_SC_PARAM_12,
//                                             BMA423_WRIST_SC_PARAM_13,BMA423_WRIST_SC_PARAM_14,BMA423_WRIST_SC_PARAM_15,BMA423_WRIST_SC_PARAM_16,BMA423_WRIST_SC_PARAM_17,BMA423_WRIST_SC_PARAM_18,
//                                             BMA423_WRIST_SC_PARAM_19,BMA423_WRIST_SC_PARAM_20,BMA423_WRIST_SC_PARAM_21,BMA423_WRIST_SC_PARAM_22,BMA423_WRIST_SC_PARAM_23,BMA423_WRIST_SC_PARAM_24,
//                                             BMA423_WRIST_SC_PARAM_25
//                                             };

static void user_delay(uint32_t period_us, void *intf_ptr)
{
    /* Implement the delay routine according to the target machine. */
    delay(period_us/1000?(period_us/1000+2):2);
}
/*!
 *  @brief Prints the execution status of the APIs.
 */
static void bma4_error_codes_print_result(const char api_name[], uint16_t rslt)
{
    #if defined(DEBUG)
    if (rslt != BMA4_OK)
    {
        Serial.printf("%s\t", api_name);
        if (rslt & BMA4_E_NULL_PTR)
        {
            Serial.printf("Error [%d] : Null pointer\r\n", rslt);
        }
        else if (rslt & BMA4_E_CONFIG_STREAM_ERROR)
        {
            Serial.printf("Error [%d] : Invalid configuration stream\r\n", rslt);
        }
        else if (rslt & BMA4_E_SELF_TEST_FAIL)
        {
            Serial.printf("Error [%d] : Self test failed\r\n", rslt);
        }
        else if (rslt & BMA4_E_INVALID_SENSOR)
        {
            Serial.printf("Error [%d] : Device not found\r\n", rslt);
        }
        else
        {
            /* For more error codes refer "*_defs.h" */
            Serial.printf("Error [%d] : Unknown error code\r\n", rslt);
        }
    }
    #endif
}

BMA::BMA(TwoWire &bus)
{
    _bus = &bus;
}

BMA::~BMA()
{
}

int8_t BMA::read(uint8_t reg_addr, uint8_t *reg_data, uint32_t length, void *intf_ptr)
{
    // return _bus->readBytes(addr, reg, data, len);

    uint16_t ret = 0;
    // xSemaphoreTakeRecursive(_i2c_mux, portMAX_DELAY);
    _bus->beginTransmission(_dev_addr);
    _bus->write(reg_addr);
    _bus->endTransmission(false);
    uint8_t cnt = _bus->requestFrom(_dev_addr, (uint8_t)length, (uint8_t)1);
    // if (!cnt)
    // {
    //     ret = 1 << 13;
    // }
    uint16_t index = 0;
    _bus->readBytes(reg_data, length);
    // while (_bus->available())
    // {
    //     // if (index > length)
    //     //     return 1 << 14;
    //     reg_data[index++] = _bus->read();
    // }
    // xSemaphoreGiveRecursive(_i2c_mux);
    // return ret;
    return 0;
}

int8_t BMA::write(uint8_t reg_addr, const uint8_t *reg_data, uint32_t length, void *intf_ptr)
{
    // return _bus->writeBytes(addr, reg, data, len);
    uint16_t ret = 0;
    // xSemaphoreTakeRecursive(_i2c_mux, portMAX_DELAY);
    _bus->beginTransmission(_dev_addr);
    _bus->write(reg_addr);
    _bus->write(reg_data, length);
    ret = _bus->endTransmission();
    // xSemaphoreGiveRecursive(_i2c_mux);
    // return ret ? 1 << 12 : ret;
    return 0;
}

/*!
 *  @brief Function to select the interface between SPI and I2C.
 */

int8_t BMA::begin()
{
    // _dev_addr = BMA4_I2C_ADDR_PRIMARY;

    _dev.intf = BMA4_I2C_INTF;
    _dev.bus_read = read;
    _dev.bus_write = write;

    /* Assign variant parameter */
    _dev.variant = BMA42X_VARIANT;//BMA42X_B_VARIANT;//BMA42X_VARIANT;

    /* Assign device address to interface pointer */
    _dev.intf_ptr = &_dev_addr;

    /* Configure delay in microseconds */
    _dev.delay_us = user_delay;

    /* Configure max read/write length (in bytes) ( Supported length depends on target machine) */
    _dev.read_write_len = 8;
    /* Sensor initialization */
    #if defined(DEBUG)
    Serial.println("bma423_init start");
    #endif
    int8_t rslt = bma423_init(&_dev);
    bma4_error_codes_print_result("bma423_init", rslt); 
     #if defined(DEBUG)
    Serial.printf("id:%02x\r\n", _dev.chip_id);
    #endif
    return rslt;
}

int8_t BMA::config()
{
    int8_t rslt ;
    /* Upload the configuration file to enable the features of the sensor. */
    #if defined(DEBUG)
    Serial.println("bma423_write_config start");
    #endif
    rslt = bma423_write_config_file(&_dev);
    bma4_error_codes_print_result("bma423_write_config", rslt);
     
    #if defined(DEBUG)
    Serial.println("bma4_set_accel_enable status start");
    #endif
    /* Enable the accelerometer */
    rslt = bma4_set_accel_enable(1, &_dev);
    bma4_error_codes_print_result("bma4_set_accel_enable status", rslt);
    
    /* Accelerometer configuration Setting */
    /* Output data Rate */
    accel_conf.odr = BMA4_OUTPUT_DATA_RATE_100HZ;

    /* Gravity range of the sensor (+/- 2G, 4G, 8G, 16G) */
    accel_conf.range = BMA4_ACCEL_RANGE_2G;

    /* Bandwidth configure number of sensor samples required to average
     * if value = 2, then 4 samples are averaged
     * averaged samples = 2^(val(accel bandwidth))
     * Note1 : More info refer datasheets
     * Note2 : A higher number of averaged samples will result in a lower noise level of the signal, but
     * since the performance power mode phase is increased, the power consumption will also rise.
     */
    accel_conf.bandwidth = BMA4_ACCEL_NORMAL_AVG4;

    /* Enable the filter performance mode where averaging of samples
     * will be done based on above set bandwidth and ODR.
     * There are two modes
     *  0 -> Averaging samples (Default)
     *  1 -> No averaging
     * For more info on No Averaging mode refer datasheets.
     */
    accel_conf.perf_mode = BMA4_CIC_AVG_MODE;

    /* Set the accel configurations */
    rslt = bma4_set_accel_config(&accel_conf, &_dev);
    bma4_error_codes_print_result("bma4_set_accel_config status", rslt);


    /* Enable step counter */
    rslt = bma423_feature_enable(BMA423_STEP_CNTR, 1, &_dev);
    bma4_error_codes_print_result("bma423_feature_enable status", rslt);

    /* Map the interrupt pin with that of step counter interrupts
     * Interrupt will  be generated when step activity is generated.
     */
    // rslt = bma423_map_interrupt(BMA4_INTR1_MAP, BMA423_STEP_CNTR_INT, 1, &_dev);
    // bma4_error_codes_print_result("bma423_map_interrupt status", rslt);

    /* Set water-mark level 1 to get interrupt after 20 steps.
     * Range of step counter interrupt is 0 to 20460(resolution of 20 steps).
     */
    // rslt = bma423_step_counter_set_watermark(1, &_dev);
    // bma4_error_codes_print_result("bma423_step_counter status", rslt);

    // bma423_stepcounter_set_parameter(&setting_wrist,&_dev);
    #if defined(DEBUG)
    struct bma423_stepcounter_settings setting;
    bma423_stepcounter_get_parameter(&setting,&_dev);


    
        Serial.printf("%04x ",setting.param1);Serial.println();
        Serial.printf("%04x ",setting.param2);Serial.println();
        Serial.printf("%04x ",setting.param3);Serial.println();
        Serial.printf("%04x ",setting.param4);Serial.println();
        Serial.printf("%04x ",setting.param5);Serial.println();
        Serial.printf("%04x ",setting.param6);Serial.println();
        Serial.printf("%04x ",setting.param7);Serial.println();
        Serial.printf("%04x ",setting.param8);Serial.println();
        Serial.printf("%04x ",setting.param9);Serial.println();
        Serial.printf("%04x ",setting.param10);Serial.println();
        Serial.printf("%04x ",setting.param11);Serial.println();
        Serial.printf("%04x ",setting.param12);Serial.println();
        Serial.printf("%04x ",setting.param13);Serial.println();
        Serial.printf("%04x ",setting.param14);Serial.println();
        Serial.printf("%04x ",setting.param15);Serial.println();
        Serial.printf("%04x ",setting.param16);Serial.println();
        Serial.printf("%04x ",setting.param17);Serial.println();
        Serial.printf("%04x ",setting.param18);Serial.println();
        Serial.printf("%04x ",setting.param19);Serial.println();
        Serial.printf("%04x ",setting.param20);Serial.println();
        Serial.printf("%04x ",setting.param21);Serial.println();
        Serial.printf("%04x ",setting.param22);Serial.println();
        Serial.printf("%04x ",setting.param23);Serial.println();
        Serial.printf("%04x ",setting.param24);Serial.println();
        Serial.printf("%04x ",setting.param25);Serial.println();

    #endif
     

    
    bma423_set_remap_axes( &remap_data, &_dev);

     
}

int8_t BMA::getRawData()
{
    /* Read the accel data */
    int8_t rslt = bma4_read_accel_xyz(&sens_data, &_dev);
    return rslt;
}

void BMA::reset()
{
    uint8_t reg = 0xB6;
    write(0x7E, &reg, 1, NULL);
}

int8_t BMA::getStepCounter(uint32_t *step_out)
{
    int8_t rslt = bma423_step_counter_output(step_out, &_dev);
    bma4_error_codes_print_result("bma423_step_counter_output status", rslt);
    return rslt;
}

//这个结果已经1000倍放大了，因此如果想获得真正的数据，需要对temp/1000，来获得浮点数
int8_t BMA::getTemperatureC(int32_t *temp)
{
    /* Get temperature in degree C */
    int8_t rslt = bma4_get_temperature(temp, BMA4_DEG, &_dev);
    bma4_error_codes_print_result("bma4_get_temperature in degree C status", rslt);
}

int8_t BMA::getTemperatureF(int32_t *temp)
{
    /* Get temperature in degree F */
    int8_t rslt = bma4_get_temperature(temp, BMA4_FAHREN, &_dev);
    bma4_error_codes_print_result("bma4_get_temperature in degree F status", rslt);
}

int8_t BMA::getTemperatureK(int32_t *temp)
{
    /* Get temperature in degree K */
    int8_t rslt = bma4_get_temperature(temp, BMA4_KELVIN, &_dev);
    bma4_error_codes_print_result("bma4_get_temperature in degree K status", rslt);
}


int8_t BMA::getAngle(Angle_t *angle)
{
 

     /* 计算x, y, z 轴倾角，返回弧度值*/
    angle->X_Angle = atan(sens_data.x/ sqrt (pow(sens_data.y,2)+pow(sens_data.z,2)));
    angle->Y_Angle = atan(sens_data.y/ sqrt (pow(sens_data.x,2)+pow(sens_data.z,2)));
    angle->Z_Angle = atan(  sqrt (pow(sens_data.y,2)+pow(sens_data.x,2))/sens_data.z);

    /* 弧度值转换为角度值 */
    angle->X_Angle = angle->X_Angle * 57.29577;
    angle->Y_Angle = angle->Y_Angle * 57.29577;
    angle->Z_Angle = angle->Z_Angle * 57.29577;
}





