#include "app_ble.h"




#include "app/app_clock.h"

BLEHidAdafruit blehid;
BLEUart bleuart; // uart over ble
static bool state_conn = false;

// callback invoked when central connects
void connect_callback(uint16_t conn_handle)
{
//   timeoutTimer.reset();
//   timeoutTimer.stop();
//   state_ble=true;
//   if(led_ble==NULL)
//   {
//     led_ble = lv_led_create(lv_scr_act(),NULL);
//     lv_obj_set_size(led_ble,10,10);
//     lv_obj_set_style_local_bg_color(led_ble,LV_LED_PART_MAIN,LV_STATE_DEFAULT,LV_COLOR_BLUE);
//     lv_obj_set_style_local_border_color(led_ble,LV_LED_PART_MAIN,LV_STATE_DEFAULT,LV_COLOR_BLACK);
//     lv_obj_set_style_local_bg_grad_color(led_ble,LV_LED_PART_MAIN,LV_STATE_DEFAULT,LV_COLOR_BLACK);
//     lv_obj_set_style_local_shadow_color(led_ble,LV_LED_PART_MAIN,LV_STATE_DEFAULT,LV_COLOR_BLACK);
    
//   }
//   // else
//   // {
//     lv_led_on(led_ble);
//     lv_obj_align(led_ble,NULL,LV_ALIGN_IN_RIGHT_MID,0,0);
//   // }
  
  
  // Get the reference to current connection
  BLEConnection* connection = Bluefruit.Connection(conn_handle);

  char central_name[32] = { 0 };
  connection->getPeerName(central_name, sizeof(central_name));

  state_conn = true;

  // Serial.print("Connected to ");
  // Serial.println(central_name);
}

/**
 * Callback invoked when a connection is dropped
 * @param conn_handle connection where this event happens
 * @param reason is a BLE_HCI_STATUS_CODE which can be found in ble_hci.h
 */
void disconnect_callback(uint16_t conn_handle, uint8_t reason)
{
    (void) conn_handle;
    (void) reason;

    state_conn = false;
//   timeoutTimer.reset();
          
//   state_ble=false;
  

//   // Serial.println();
//   // Serial.print("Disconnected, reason = 0x"); Serial.println(reason, HEX);
//   if(led_ble !=NULL)
//   {
//     lv_led_off(led_ble);
//     // lv_obj_del(led_ble);
//     // led_ble = NULL;
//   }
}
static void startAdv(void)
{
  // Advertising packet
  Bluefruit.Advertising.addFlags(BLE_GAP_ADV_FLAGS_LE_ONLY_GENERAL_DISC_MODE);
  Bluefruit.Advertising.addTxPower();

  // Include bleuart 128-bit uuid
  Bluefruit.Advertising.addService(bleuart);

  // Secondary Scan Response packet (optional)
  // Since there is no room for 'Name' in Advertising packet
  Bluefruit.ScanResponse.addName();
  
  /* Start Advertising
   * - Enable auto advertising if disconnected
   * - Interval:  fast mode = 20 ms, slow mode = 152.5 ms
   * - Timeout for fast mode is 30 seconds
   * - Start(timeout) with timeout = 0 will advertise forever (until connected)
   * 
   * For recommended advertising interval
   * https://developer.apple.com/library/content/qa/qa1931/_index.html   
   */
  Bluefruit.Advertising.restartOnDisconnect(true);
  Bluefruit.Advertising.setInterval(120, 244);    // in unit of 0.625 ms
  Bluefruit.Advertising.setFastTimeout(30);      // number of seconds in fast mode
  Bluefruit.Advertising.start(0);                // 0 = Don't stop advertising after n seconds  
}

void prph_bleuart_rx_callback(uint16_t conn_handle)
{
  (void) conn_handle;

  // Forward data from Mobile to our peripheral
  char str[20 + 1] = { 0 };
  bleuart.read(str, 20);

  //set date and time
  //command: AT+DT=
  //format: YYYYMMDDHHMMSS
  String prphInString = str;
  String DateTimeString = "";
  if (prphInString.indexOf("AT+DT=") >= 0 ) {
    //****************************set date and time****************************
    DateTimeString = prphInString.substring(6, 19);
    app_clock_set_time_str(DateTimeString);
    // if (!insideMenue) mainScreen();
    //Scheduler.startLoop(loop2);
  } else if (prphInString.indexOf("AT+SE=") >= 0) {
    //****************************for the BLE Sensors app****************************
    // if (insideBLEsensors) {
    //   display.fillRect(0, 25, 176, 176, LCD_COLOR_BLACK);
    //   display.setTextSize(2);
    //   display.setTextColor(LCD_COLOR_CYAN);
    //   display.setCursor(0, 25);
    //   display.println(prphInString.substring(6));
    //   display.refresh();
    // }

  } else if (prphInString.indexOf("AT+NO=") >= 0) {
    //****************************receive notification****************************
    // notificationHere = true;
    // notificationString = prphInString.substring(6);
    // if (!insideMenue) mainScreen();
    // nTimesVibe(4, 200); //vibrate!
  }

  // Serial.print("[Prph] RX: ");
  // Serial.println(str);

  // if ( clientUart.discovered() )
  // {
  //   clientUart.print(str);
  // } else
  // {
  //   bleuart.println("[Prph] Central role not connected");
  // }
}
void app_ble_config(void)
{
  // Config the peripheral connection with maximum bandwidth 
  // more SRAM required by SoftDevice
  // Note: All config***() function must be called before begin()
  Bluefruit.configPrphBandwidth(BANDWIDTH_MAX);
  Bluefruit.begin();
  Bluefruit.setTxPower(4);    // Check bluefruit.h for supported values
  Bluefruit.setName("Modular-NOW");
  //Bluefruit.setName(getMcuUniqueID()); // useful testing with multiple central connections
  Bluefruit.Periph.setConnectCallback(connect_callback);
  Bluefruit.Periph.setDisconnectCallback(disconnect_callback);


  // Configure and Start BLE Uart Service
  // bleuart.begin();
  // bleuart.setRxCallback(prph_bleuart_rx_callback);

  // // BLE HID
  // blehid.begin();

  // Set up and start advertising
  // startAdv();
}

bool app_ble_get_state_conn(void)
{
  return state_conn;
}










