// // The MIT License (MIT)
// // Copyright (c) 2019 Ha Thach for Adafruit Industries

// #include "app_extflash.h"
// // #include "SdFat.h"
// // #include "Adafruit_SPIFlash.h"
// #include "board/board.h"

// #include <SPI.h>

//  #include "../lib/Arduino-LittleFS-SpiMemory-Wrapper-master/SPIMemory-3.4.0/src/SPIMemory.h"
// #include "LFSWrapper.h"
// #include "LFSInterface.h"

// #define FLASH_CS_H digitalWrite(PIN_FLASH_CS,HIGH)
// #define FLASH_CS_L digitalWrite(PIN_FLASH_CS,LOW)

// // On-board external flash (QSPI or SPI) macros should already
// // defined in your board variant if supported
// // - EXTERNAL_FLASH_USE_QSPI
// // - EXTERNAL_FLASH_USE_CS/EXTERNAL_FLASH_USE_SPI

// static SPIClass EXTFLASH_SPI(NRF_SPIM1, PIN_FLASH_MISO, PIN_FLASH_SCLK, PIN_FLASH_MOSI);

// #define EXT_FLASH_SS      PIN_FLASH_CS

// SPIFlash flash(EXT_FLASH_SS, &EXTFLASH_SPI);
// LfsInstance extFlashFs;

// LfsFile radioConfig(&extFlashFs);
// LfsFile MlxCalConfig(&extFlashFs);

// void printfile();

// // the setup function runs once when you press reset or power the board
// void app_extflash_init(void)
// {
//     //   Serial.begin(115200);
//     //   while ( !Serial ) delay(10);   // wait for native usb

//     //   flash.begin();

//     //   Serial.println("Adafruit Serial Flash Info example");
//     //   Serial.print("JEDEC ID: "); Serial.println(flash.getJEDECID(), HEX);
//     //   Serial.print("Flash size: "); Serial.println(flash.size());
//     printfile();
// }

// void printfile()
// {
//     // Initialize serial port and wait for it to open before continuing.
//     Serial.begin(115200);
//     while (!Serial)
//     {
//         delay(100);
//     }
//     Serial.println("Adafruit SPI Flash FatFs Simple File Printing Example");

//     digitalWrite(PIN_FLASH_CS,HIGH);
//     pinMode(PIN_FLASH_CS,OUTPUT);

//     EXTFLASH_SPI.begin();

//     // FLASH_CS_L;
//     // EXTFLASH_SPI.beginTransaction(SPISettings(8000000, MSBFIRST, SPI_MODE0));

//     // uint8_t writeData[4]={0x9f,0x00,0x00,0x00};
//     // uint8_t readData[4];
//     // EXTFLASH_SPI.transfer(writeData, readData, 4);
//     // EXTFLASH_SPI.endTransaction();
//     // FLASH_CS_H;

//     //  Serial.printf("%02x,%02x,%02x,%02x",readData[0],readData[1],readData[2],readData[3]);

//      flash.begin();
//   Serial.println("Init Flash");
//   extFlashFs.configure(SpiFlashLfsCfg);
//   extFlashFs.mount();
//   if (extFlashFs.errorState()) {
//     Serial.print("error state:");
//     Serial.print(extFlashFs.errorState(), HEX);
//     Serial.println("; formatting drive...");
//     extFlashFs.format();
//     extFlashFs.mount();
//   }
//   // Running total of how many resets:
//   LfsFile boot_count(&extFlashFs, "boot_count", LFS_O_RDWR | LFS_O_CREAT);
//   byte boot_count_num;
//   boot_count.read(&boot_count_num, 1);
//   Serial.print("boot count num: ");
//   Serial.println(boot_count_num);
//   boot_count_num += 1;
//   boot_count.rewind();
//   boot_count.write(&boot_count_num, 1);
//   // Your writes are not saved until you close the file!
//   boot_count.close();
// }

#include "app_extflash.h"

#include "board/board.h"

#include <SPI.h> 

#define FLASH_CS_H digitalWrite(PIN_FLASH_CS,HIGH)
#define FLASH_CS_L digitalWrite(PIN_FLASH_CS,LOW)
 
#define SPIFLASH_WRITEENABLE      0x06        // write enable
#define SPIFLASH_WRITEDISABLE     0x04        // write disable

#define SPIFLASH_BLOCKERASE_4K    0x20        // erase one 4K block of flash memory
#define SPIFLASH_BLOCKERASE_32K   0x52        // erase one 32K block of flash memory
#define SPIFLASH_BLOCKERASE_64K   0xD8        // erase one 64K block of flash memory
#define SPIFLASH_CHIPERASE        0x60        // chip erase (may take several seconds depending on size)
                                              // but no actual need to wait for completion (instead need to check the status register BUSY bit)
#define SPIFLASH_STATUSREAD       0x05        // read status register
#define SPIFLASH_STATUSWRITE      0x01        // write status register
#define SPIFLASH_ARRAYREAD        0x0B        // read array (fast, need to add 1 dummy byte after 3 address bytes)
#define SPIFLASH_ARRAYREADLOWFREQ 0x03        // read array (low frequency)

#define SPIFLASH_SLEEP            0xB9        // deep power down
#define SPIFLASH_WAKE             0xAB        // deep power wake up
#define SPIFLASH_BYTEPAGEPROGRAM  0x02        // write (1 to 256bytes)
#define SPIFLASH_IDREAD           0x9F        // read JEDEC manufacturer and device ID (2 bytes, specific bytes for each manufacturer and device)
                                              // Example for Atmel-Adesto 4Mbit AT25DF041A: 0x1F44 (page 27: http://www.adestotech.com/sites/default/files/datasheets/doc3668.pdf)
                                              // Example for Winbond 4Mbit W25X40CL: 0xEF30 (page 14: http://www.winbond.com/NR/rdonlyres/6E25084C-0BFE-4B25-903D-AE10221A0929/0/W25X40CL.pdf)
#define SPIFLASH_MACREAD          0x4B        // read unique ID number (MAC)
         
static SPIClass EXTFLASH_SPI(NRF_SPIM1, PIN_FLASH_MISO, PIN_FLASH_SCLK, PIN_FLASH_MOSI);


// #include "SPIFlash.h" //get it here: https://github.com/LowPowerLab/SPIFlash
void app_extflash_init(void)
{
    // Serial.begin(115200);
    // while (!Serial)
    // {
    //     delay(100);
    // }
    // Serial.println("Adafruit SPI Flash FatFs Simple File Printing Example");

    // digitalWrite(PIN_FLASH_CS,HIGH);
    // pinMode(PIN_FLASH_CS,OUTPUT);

    // EXTFLASH_SPI.begin();

    

    // FLASH_CS_L;
    // EXTFLASH_SPI.beginTransaction(SPISettings(8000000, MSBFIRST, SPI_MODE0));

    // uint8_t writeData[5]={SPIFLASH_WAKE,0x00,0x00,0x00,0x00};
    // uint8_t readData[5];
    // EXTFLASH_SPI.transfer(writeData, readData, 5);
    // delay(1);
    // EXTFLASH_SPI.endTransaction();
    // FLASH_CS_H;



    // FLASH_CS_L;
    // EXTFLASH_SPI.beginTransaction(SPISettings(8000000, MSBFIRST, SPI_MODE0));

    // uint8_t writeData1[4]={SPIFLASH_IDREAD,0x00,0x00,0x00};
    // uint8_t readData1[4];
    // EXTFLASH_SPI.transfer(writeData1, readData1, 4);
    // EXTFLASH_SPI.endTransaction();
    // FLASH_CS_H;

    //  Serial.printf("%02x,%02x,%02x,%02x\n",readData1[0],readData1[1],readData1[2],readData1[3]);





    // FLASH_CS_L;
    // EXTFLASH_SPI.beginTransaction(SPISettings(8000000, MSBFIRST, SPI_MODE0));

    // uint8_t writeData2[4]={SPIFLASH_SLEEP,0x00,0x00,0x00};
    // uint8_t readData2[4];
    // EXTFLASH_SPI.transfer(writeData2, readData2, 1);
    
    // EXTFLASH_SPI.endTransaction();
    // delay(1);
    // FLASH_CS_H;





 

    // EXTFLASH_SPI.end();
    // Serial.end();

}