#include "app_hwinfo.h"
#include <Arduino.h>
#if defined(NRF52)

typedef volatile uint32_t REG32;
#define pREG32 (REG32 *)

#define DEVICE_ID_HIGH    (*(pREG32 (0x10000060)))
#define DEVICE_ID_LOW     (*(pREG32 (0x10000064)))
#define MAC_ADDRESS_HIGH  (*(pREG32 (0x100000a8)))
#define MAC_ADDRESS_LOW   (*(pREG32 (0x100000a4)))

void app_hwinfo_get_mac(char *mac)
{
    // MAC Address
  uint32_t addr_high = ((MAC_ADDRESS_HIGH) & 0x0000ffff) | 0x0000c000;
  uint32_t addr_low  = MAC_ADDRESS_LOW;

  sprintf(mac,"%02X-%02X-%02X-%02X-%02X-%02X",(addr_high >> 8) & 0xFF,(addr_high) & 0xFF,(addr_low >> 24) & 0xFF,(addr_low >> 16) & 0xFF,(addr_low >> 8) & 0xFF,(addr_low) & 0xFF);
    
}
void app_hwinfo_get_chipid(char *id)
{
    sprintf(id,"%08X%08X",DEVICE_ID_HIGH,DEVICE_ID_LOW);
}

  // MCU Variant;
//   Serial.printf("MCU Variant: nRF%X 0x%08X\n",NRF_FICR->INFO.PART, NRF_FICR->INFO.VARIANT);
//   Serial.printf("Memory     : Flash = %d KB, RAM = %d KB\n", NRF_FICR->INFO.FLASH, NRF_FICR->INFO.RAM);


#elif defined(ESP32)

void app_hwinfo_get_mac(char *mac)
{

}
void app_hwinfo_get_chipid(char *id)
{

}

#endif