
#include "page/page_manager.h"
#include "page/page_clock.h"
#include "page/page_date.h"
#include "page/page_motion.h"
#include "page/page_env.h"
#include "page/effect/page_swirl.h"
#include "page/sys/page_hour_set.h"
#include "page/sys/page_year_set.h"
#include "page/sys/page_mon_Set.h"
#include "page/sys/page_day_set.h"
#include "page/sys/page_min_set.h"
#include "page/sys/page_time_select.h"

page_t page_god; // 总页面
page_t page_motion;
page_t page_swirl;
page_t page_clock;
page_t page_env;
page_t page_date;

page_t page_time_select;
page_t page_hour_set;
page_t page_min_set;
page_t page_year_set;
page_t page_mon_set;
page_t page_day_set;

void page_create(void)
{
  page_item_reset(&page_god);
  page_item_reset(&page_motion);
  page_item_reset(&page_swirl);
  page_item_reset(&page_clock);
  page_item_reset(&page_date);
  page_item_reset(&page_env);

  page_item_reset(&page_time_select);
  page_item_reset(&page_year_set);
  page_item_reset(&page_mon_set);
  page_item_reset(&page_day_set);
  page_item_reset(&page_hour_set);
  page_item_reset(&page_min_set);


  page_item_set_cb(&page_clock, (enter_cb_t)page_clock_enter, (loop_cb_t)page_clock_loop, (exit_cb_t)page_clock_exit);
   page_item_set_cb(&page_date, (enter_cb_t)page_date_enter, (loop_cb_t)page_date_loop, (exit_cb_t)page_date_exit);
  page_item_set_cb(&page_motion, (enter_cb_t)page_motion_enter, (loop_cb_t)page_motion_loop, (exit_cb_t)page_motion_exit);
  page_item_set_cb(&page_swirl, (enter_cb_t)page_swirl_enter, (loop_cb_t)page_swirl_loop, (exit_cb_t)page_swirl_exit);
  page_item_set_cb(&page_env, (enter_cb_t)page_env_enter, (loop_cb_t)page_env_loop, (exit_cb_t)page_env_exit);

  page_item_set_cb(&page_time_select, (enter_cb_t)page_time_select_enter, (loop_cb_t)page_time_select_loop, (exit_cb_t)page_time_select_exit);
  page_item_set_cb(&page_year_set, (enter_cb_t)page_year_set_enter, (loop_cb_t)page_year_set_loop, (exit_cb_t)page_year_set_exit);
  page_item_set_cb(&page_mon_set, (enter_cb_t)page_mon_set_enter, (loop_cb_t)page_mon_set_loop, (exit_cb_t)page_mon_set_exit);
  page_item_set_cb(&page_day_set, (enter_cb_t)page_day_set_enter, (loop_cb_t)page_day_set_loop, (exit_cb_t)page_day_set_exit);
  page_item_set_cb(&page_hour_set, (enter_cb_t)page_hour_set_enter, (loop_cb_t)page_hour_set_loop, (exit_cb_t)page_hour_set_exit);
  page_item_set_cb(&page_min_set, (enter_cb_t)page_min_set_enter, (loop_cb_t)page_min_set_loop, (exit_cb_t)page_min_set_exit);


  page_item_add_child(&page_god, &page_clock, false);
  page_item_add_child(&page_god, &page_date, false);
  page_item_add_child(&page_god, &page_motion, false);
  page_item_add_child(&page_god, &page_env, true);
  
 

  page_item_add_child(&page_clock, &page_time_select, false);

  page_item_add_child(&page_time_select, &page_year_set, false);
  page_item_add_child(&page_time_select, &page_mon_set, false);
  page_item_add_child(&page_time_select, &page_day_set, false);
  page_item_add_child(&page_time_select, &page_hour_set, false);
  page_item_add_child(&page_time_select, &page_min_set, false);

  page_item_add_child(&page_env, &page_swirl, false);
  

  manager.cur = &page_clock;
  manager.old = NULL;
  manager.busy = false;

  if (manager_init() == false)
  {
    // tft.setCursor(0, 0);
    // tft.setTextColor(TFT_RED);
    // tft.println("manager init fail");
    delay(1000);
  }
  else
  {
    manager.cur->enter(NULL);
    // tft.println("manager init success");
    if (manager_loop_start())
    {

      // tft.println("manager loop start init success");
    }
    else
    {
      // tft.setCursor(0, 0);
      // tft.setTextColor(TFT_RED);
      // tft.println("manager loop start init fail");
      delay(1000);
    }
  }
}