#include "page_env.h"
#include "app/app_motion.h"
#include "app/app_key.h"
// #include "app/app_anim.h"
#include "page/page_manager.h"
 
#include "page/page_include.h"
static int temper;

static void fadeIn()
{
   int16_t x1, y1;
    uint16_t w, h;
    char buffer[20];
    sprintf(buffer, "%+d", temper);
    matrix.getTextBounds(buffer, 0, 0, &x1, &y1, &w, &h);
   iic_setPins(PIN_SDA_IS31,PIN_SCL_IS31);
   Wire.setClock(400000);   
   matrix.setFont(&Org_01);
   for(uint8_t i=0;i<16;i++)
   {
      matrix.setCursor(1,4+2);
      matrix.setTextColor(i);
      matrix.print(buffer);
      delay(10);
   }
   
}

static void fadeOut()
{
   int16_t x1, y1;
    uint16_t w, h;
    char buffer[20];
    sprintf(buffer, "%+d", temper);
    matrix.getTextBounds(buffer, 0, 0, &x1, &y1, &w, &h);
   iic_setPins(PIN_SDA_IS31,PIN_SCL_IS31);
   Wire.setClock(400000);   
   matrix.setFont(&Org_01);
   for(int8_t i=16;i>0;i--)
   {
      matrix.setCursor(1,4+2);
      matrix.setTextColor(i);
      matrix.print(buffer);
      delay(10);
   }
   
}
void *page_env_enter(void *data)
{
   iic_setPins(PIN_SDA,PIN_SCL);
   Wire.setClock(400000);   
   temper = app_motion_get_temperature() / 1000 - 8;

   // iic_setPins(PIN_SDA_IS31,PIN_SCL_IS31);
   // Wire.setClock(400000);   
   // matrix.setFont(&Org_01);
   // matrix.setCursor(0,4+2);
   // matrix.setTextColor(16);
   // matrix.printf("%1d%1d",temper/10,temper%10);
fadeIn();
   app_key_clean();
  manager_set_busy_state(false);
   return NULL;
}

//根据按键情况，对其进行不同操作处理
void page_env_loop(void *data)
{
   KEY_TYPE key = app_key_get();
   switch (key)
   {
   case KEY0_SHORT:
      manager_switch(LEVEL_PREV);

      break;
   case KEY1_SHORT:
      manager_switch(LEVEL_NEXT);
      break;
   case KEY0_LONG:
      //    manager_switch(LEVEL_PARENT);
      break;
   case KEY1_LONG:
      if (manager.cur->child != NULL)
        {
            manager_switch(LEVEL_CHILD);
        }
      break;

   default:
      break;
   }
}

void page_env_exit(void *data)
{
   fadeOut();
   iic_setPins(PIN_SDA_IS31,PIN_SCL_IS31);
   Wire.setClock(400000);   
   matrix.clear();
   // lv_task_del(task);
   //退出动画，进行切换
   
}
