#include "page_motion.h"
#include "app/app_motion.h"
#include "app/app_key.h"
// #include "app/app_anim.h"
// #include "lvgl.h"
#include <Arduino.h>

#include "page/page_include.h"

static const uint8_t str_step[] = {0xEF, 0xCB, 0x81, 0xEF, 0xAB, 0xCD, 0xEF, 0xF1}; /*"步",0*/

static uint32_t step_current;       //当时步数
static uint32_t step_remain;        //剩余步数
static uint32_t step_target = 3000; //目标步数
static void fadeIn(void)
{
    int16_t x = 5;
    int16_t y = 3;
    int16_t x1, y1;
    uint16_t w, h;
    char buffer[20];

    // Serial.println(step_current);
    iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
    Wire.setClock(400000);
    matrix.setRotation(0);
    matrix.clear();
    matrix.setTextWrap(false);

    matrix.setTextSize(1);
    matrix.setFont(&TomThumb);

    for (uint8_t i = 0; i < 16; i++)
    {
        matrix.setTextColor(i); // quarter brightness

        if (step_current < 1000)
        {
            sprintf(buffer, "%d", step_current);
            matrix.getTextBounds(buffer, 0, 0, &x1, &y1, &w, &h);
            matrix.setCursor(16 - w + x, 4 + y);
            matrix.print(buffer);
        }
        else if (step_current < 1000000)
        {
            sprintf(buffer, "%dK", step_current / 1000);
            matrix.getTextBounds(buffer, 0, 0, &x1, &y1, &w, &h);
            matrix.setCursor(16 - w + x, 4 + y);
            matrix.print(buffer);
        }
        else
        {
            sprintf(buffer, "%dM", step_current / 1000000);
            matrix.getTextBounds(buffer, 0, 0, &x1, &y1, &w, &h);
            matrix.setCursor(16 - w + x, 4 + y);
            matrix.print(buffer);
        }
        // Serial.println(x1);
        // Serial.println(y1);
        // Serial.println(w);
        // Serial.println(h);

        delay(10);
    }
}

static void fadeOut(void)
{
    int16_t x = 5;
    int16_t y = 3;
    int16_t x1, y1;
    uint16_t w, h;
    char buffer[20];
    // Serial.println(step_current);
    iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
    Wire.setClock(400000);

    matrix.setTextSize(1);
    matrix.setFont(&TomThumb);

    for (int8_t i = 16; i > 0; i--)
    {
        matrix.setTextColor(i); // quarter brightness

        if (step_current < 1000)
        {
            sprintf(buffer, "%d", step_current);
            matrix.getTextBounds(buffer, 0, 0, &x1, &y1, &w, &h);
            matrix.setCursor(16 - w + x, 4 + y);
            matrix.print(buffer);
        }
        else if (step_current < 1000000)
        {
            sprintf(buffer, "%dK", step_current / 1000);
            matrix.getTextBounds(buffer, 0, 0, &x1, &y1, &w, &h);
            matrix.setCursor(16 - w + x, 4 + y);
            matrix.print(buffer);
        }
        else
        {
            sprintf(buffer, "%dM", step_current / 1000000);
            matrix.getTextBounds(buffer, 0, 0, &x1, &y1, &w, &h);
            matrix.setCursor(16 - w + x, 4 + y);
            matrix.print(buffer);
        }
        delay(10);
    }
}
static int16_t xpos;
static void task_time_update(TimerHandle_t xTimerID)
{
    int16_t x1, y1;
    uint16_t w, h;
    char buffer[20];
    sprintf(buffer, "%d", step_current);
    matrix.getTextBounds(buffer, 0, 0, &x1, &y1, &w, &h);

    if (w > 16)
    {
        int16_t x = 0;
        int16_t y = 2;
        // Serial.println(step_current);
        iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
        Wire.setClock(400000);

        matrix.setTextSize(1);
        matrix.setFont(&Org_01);
        matrix.setTextColor(16); // quarter brightness
        matrix.setCursor(xpos + x, 4 + y);
        matrix.printf("%d", step_current);
        xpos--;
        if ((xpos + w) == 0)
        {
        }
    }
}

// static void loader_anim_cb(void * arc, lv_anim_value_t v);
// static void anim_in_ready_cb(lv_anim_t * a);

void *page_motion_enter(void *data)
{

    // Serial.println("enter");
    iic_setPins(PIN_SDA, PIN_SCL);
    Wire.setClock(400000);
    app_motion_get_step(&step_current);
    // step_current+=1500;

    step_remain = (step_target >= step_current) ? (step_target - step_current) : 0;
    uint8_t percent = (step_target >= step_current) ? (step_current * 100 / step_target) : 100;

    
    fadeIn();

    //draw percent
    matrix.drawPixel(1,0,1);
    matrix.drawPixel(2,0,1);
    matrix.drawPixel(3,0,1);
    matrix.drawPixel(1,1,1);
    matrix.drawPixel(2,1,1);
    matrix.drawPixel(1,2,1);
    matrix.drawFastVLine(0,0,9,1);
    for(uint8_t i=0;i<percent*9/100;i++)
    {
        delay(50);
        matrix.drawPixel(0,9-i-1,8);
        
    }
    


    // selfTimer.begin(100, task_time_update);
    // selfTimer.start();

    app_key_clean();
    manager_set_busy_state(false);

    //进入动画，进行切换
    // obj_anim_in(scr,100,100,anim_in_ready_cb,NULL);
    return NULL;
}

// static void anim_in_ready_cb(lv_anim_t * a)
// {
//     app_key_clean();
//     manager_set_busy_state(false);

// }
// static void loader_anim_cb(void * arc, lv_anim_value_t v)
// {
//     if(v > 100) v = 100;
//     lv_arc_set_end_angle((lv_obj_t *)arc, v * 360 / 100 + 270);

//     static char buf[32];
//     lv_snprintf(buf, sizeof(buf), "%d %%", v);
//     lv_obj_set_style_local_value_str((lv_obj_t *)arc, LV_ARC_PART_BG, LV_STATE_DEFAULT, buf);
//     lv_obj_set_style_local_value_color((lv_obj_t *)arc, LV_ARC_PART_BG, LV_STATE_DEFAULT, LV_COLOR_GREEN);
// }

// static void anim_out_ready_cb(lv_anim_t * a)
// {
//    lv_obj_del(scr);

// }
void page_motion_exit(void *data)
{
    fadeOut();

    iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
    Wire.setClock(400000);
    matrix.clear();

    // //   lv_task_del(task);
    //   //退出动画，进行切换
    //   obj_anim_out(scr,100,0,anim_out_ready_cb,NULL);
}

//根据按键情况，对其进行不同操作处理
void page_motion_loop(void *data)
{
    // Serial.println("loop");
    KEY_TYPE key = app_key_get();
    // Serial.println(key);
    switch (key)
    {
    case KEY0_SHORT:
        manager_switch(LEVEL_PREV);
        break;
    case KEY1_SHORT:
        manager_switch(LEVEL_NEXT);
        break;
    case KEY0_LONG:
        //  manager_switch(LEVEL_PARENT);
        break;
    case KEY1_LONG:
        // manager_switch(LEVEL_CHILD);
        break;

    default:
        break;
    }
}