#include "page_hour_set.h"
#include "page_time_select.h"

#include <Arduino.h>

#include "app/app_clock.h"
#include "board/board.h"
#include "app/app_key.h"
// #include "app/app_anim.h"
#include "page/page_manager.h"

#include "page/page_include.h"

// //年(0) 月(1) 日(2) 时(3) 分(4) 秒(5) dengxianlight
// static const uint8_t img_time[] = {
//     //16*9
//     0x04, 0x00, 0x1F, 0xFF, 0x20, 0x40, 0x0F, 0xFE, 0x08, 0x40, 0x3F, 0xFF, 0x00, 0x40, 0x00, 0x40,
//     0x00, 0x00, /*"年",0*/
//     0x0F, 0xFC, 0x08, 0x04, 0x0F, 0xFC, 0x08, 0x04, 0x0F, 0xFC, 0x08, 0x04, 0x08, 0x04, 0x30, 0x0C,
//     0x00, 0x00, /*"月",1*/
//     0x00, 0x00, 0x0F, 0xFE, 0x08, 0x02, 0x0F, 0xFE, 0x08, 0x02, 0x08, 0x02, 0x0F, 0xFE, 0x08, 0x02,
//     0x00, 0x00, /*"日",2*/
//     0x00, 0x04, 0x3E, 0x04, 0x22, 0xFF, 0x3E, 0x04, 0x22, 0x64, 0x22, 0x14, 0x3E, 0x04, 0x22, 0x0C,
//     0x00, 0x00, /*"时",3*/
//     0x02, 0x20, 0x04, 0x10, 0x08, 0x0C, 0x36, 0xF7, 0x41, 0x08, 0x02, 0x08, 0x04, 0x08, 0x38, 0x38,
//     0x00, 0x00, /*"分",4*/
//     0x37, 0x08, 0x08, 0x08, 0x7B, 0x29, 0x0C, 0x48, 0x3B, 0x89, 0x48, 0x0A, 0x08, 0x0C, 0x08, 0xF0,
//     0x00, 0x00, /*"秒",5*/

// };
static uint8_t hour;
static uint8_t old;
static bool am;
void *page_hour_set_enter(void *data)
{
    iic_setPins(PIN_SDA, PIN_SCL);
    Wire.setClock(400000);
    date = rtc.getDateTime();
    if (date.hour > 12)
    {
        am = false;
    }
    else
    {
        am = true;
    }
    hour = date.hour;

    old = hour;

    iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
    Wire.setClock(400000);

    //显示年月日时分秒

    for (int8_t i = 0; i >= -16; i--)
    {
        matrix.clear();
        matrix.drawBitmap(i, 0, &img_time[18 * 3], 16, 9, 16);

        matrix.setCursor(0 + i + 16, 5);
        matrix.setTextColor(16);
        matrix.setFont(&Org_01);
        matrix.printf("%d", hour % 12 ? hour % 12 : 12);

        matrix.setTextColor(10);
        matrix.setFont(&TomThumb);
        matrix.setCursor(9 + i + 16, 7);
        matrix.printf("%s", am ? "AM" : "PM");

        delay(10);
    }

    // matrix.clear();
    // matrix.setCursor(0, 5);
    // matrix.setTextColor(16);
    // matrix.setFont(&Org_01);
    // matrix.printf("%d", hour % 12 ? hour % 12 : 12);

    // matrix.setTextColor(10);
    // matrix.setFont(&TomThumb);
    // matrix.setCursor(9, 7);
    // matrix.printf("%s", am ? "AM" : "PM");

    app_key_clean();
    manager_set_busy_state(false);
    return NULL;
}

//根据按键情况，对其进行不同操作处理
void page_hour_set_loop(void *data)
{
    KEY_TYPE key = app_key_get();

    switch (key)
    {
    case KEY0_SHORT:
        hour--;
        if (hour == 0)
        {
            hour = 24;
        }

        iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
        Wire.setClock(400000);

        matrix.setFont(&Org_01);

        matrix.setCursor(0, 5);
        matrix.setTextColor(0);
        matrix.printf("%d", old % 12 ? old % 12 : 12);

        matrix.setTextColor(16);
        matrix.setCursor(0, 5);
        matrix.printf("%d", hour % 12 ? hour % 12 : 12);

        old = hour;

        if (hour > 12)
        {

            if (am == true)
            {
                matrix.setFont(&TomThumb);

                matrix.setTextColor(0);
                matrix.setCursor(9, 7);
                matrix.print("AM");

                matrix.setTextColor(10);
                matrix.setCursor(9, 7);
                matrix.print("PM");
            }

            am = false;
        }
        else
        {

            if (am == false)
            {
                matrix.setFont(&TomThumb);

                matrix.setTextColor(0);
                matrix.setCursor(9, 7);
                matrix.print("PM");

                matrix.setTextColor(10);
                matrix.setCursor(9, 7);
                matrix.print("AM");
            }

            am = true;
        }

        //   manager_switch(LEVEL_PREV);
        break;
    case KEY1_SHORT:
        //   manager_switch(LEVEL_NEXT);
        hour++;
        if (hour == 24)
        {
            hour = 0;
        }
        iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
        Wire.setClock(400000);

        matrix.setFont(&Org_01);

        matrix.setCursor(0, 5);
        matrix.setTextColor(0);
        matrix.printf("%d", old % 12 ? old % 12 : 12);

        matrix.setCursor(0, 5);
        matrix.setTextColor(16);
        matrix.printf("%d", hour % 12 ? hour % 12 : 12);
        old = hour;
        if (hour > 12)
        {

            if (am == true)
            {
                matrix.setFont(&TomThumb);

                matrix.setTextColor(0);
                matrix.setCursor(9, 7);
                matrix.print("AM");

                matrix.setTextColor(10);
                matrix.setCursor(9, 7);
                matrix.print("PM");
            }

            am = false;
        }
        else
        {

            if (am == false)
            {
                matrix.setFont(&TomThumb);

                matrix.setTextColor(0);
                matrix.setCursor(9, 7);
                matrix.print("PM");

                matrix.setTextColor(10);
                matrix.setCursor(9, 7);
                matrix.print("AM");
            }

            am = true;
        }

        break;
    case KEY0_LONG:

        manager_switch(LEVEL_PARENT);
        break;
    case KEY1_LONG:
        //获取相关时间

        iic_setPins(PIN_SDA, PIN_SCL);
        Wire.setClock(400000);
        date = rtc.getDateTime();
        date.hour = hour;

        rtc.setDateTime(date);
        manager_switch(LEVEL_PARENT);
        break;

    default:
        break;
    }
}

void page_hour_set_exit(void *data)
{

    // lv_task_del(task);
    //退出动画，进行切换
}
