#include "page_time_select.h"

#include <Arduino.h>

#include "app/app_clock.h"
#include "board/board.h"
#include "app/app_key.h"
// #include "app/app_anim.h"
#include "page/page_manager.h"

#include "page/page_include.h"

static uint8_t item = 0;

//年(0) 月(1) 日(2) 时(3) 分(4) 秒(5) dengxianlight
const unsigned char img_time[] = {
    //16*9
    0x08, 0x00, 0x1F, 0xF0, 0x61, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x11, 0x00, 0x2F, 0xE0, 0x01, 0x00,
    0x00, 0x00, /*"年",0*/
    0x00, 0x00, 0x1F, 0xC0, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x20, 0x40, 0x20, 0xC0,
    0x00, 0x00, /*"月",1*/
    0x00, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20,
    0x00, 0x00, /*"日",2*/
    0x00, 0x20, 0x78, 0x20, 0x4B, 0xF0, 0x78, 0x20, 0x49, 0x20, 0x48, 0x20, 0x78, 0x20, 0x40, 0xC0,
    0x00, 0x00, /*"时",3*/
    0x09, 0x00, 0x08, 0x80, 0x10, 0x40, 0x7F, 0xF0, 0x04, 0x40, 0x04, 0x40, 0x08, 0x40, 0x33, 0x80,
    0x00, 0x00, /*"分",4*/
    0x2C, 0x40, 0x10, 0x80, 0x3D, 0x90, 0x12, 0x90, 0x3A, 0x90, 0x54, 0xA0, 0x10, 0x40, 0x13, 0x80,
    0x00, 0x00, /*"秒",5*/

};

void *page_time_select_enter(void *data)
{

    iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
    Wire.setClock(400000);

    //显示年月日时分秒

    matrix.clear();
    matrix.drawBitmap(0, 0, &img_time[item * 18], 16, 9, 16);

    app_key_clean();
    manager_set_busy_state(false);
    return NULL;
}

//根据按键情况，对其进行不同操作处理
void page_time_select_loop(void *data)
{
    KEY_TYPE key = app_key_get();
    switch (key)
    {
    case KEY0_SHORT:
        if (item > 0)
        {
            item--;
            iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
            Wire.setClock(400000);
            matrix.clear();
            for (int8_t i = 0; i < 16; i++)
            {
                 matrix.clear();
                matrix.drawBitmap(i, 0, &img_time[18 * (item + 1)], 16, 9, 16);
                matrix.drawBitmap(i - 16, 0, &img_time[18 * item], 16, 9, 16);
                delay(10);
            }
        }
        break;
    case KEY1_SHORT:
        if (item < 5 )
        {
            item++;
            iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
            Wire.setClock(400000);
            matrix.clear();
            for (int8_t i = 0; i > -16; i--)
            {
                matrix.clear();
                matrix.drawBitmap(i, 0, &img_time[18 * (item - 1)], 16, 9, 16);
                matrix.drawBitmap(i + 16, 0, &img_time[18 * item], 16, 9, 16);
                delay(10);
            }
        }

        break;
    case KEY0_LONG:
        item = 0;
        manager_switch(LEVEL_PARENT);

        //显示年月日时分秒

        matrix.clear();

        break;
    case KEY1_LONG:
        if (manager.cur->child != NULL)
        {
            manager_switch_child(item);
        }

        break;

    default:
        break;
    }
}

void page_time_select_exit(void *data)
{
    iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
    Wire.setClock(400000);
    matrix.clear();
    // lv_task_del(task);
    //退出动画，进行切换
}
