#include "page_year_set.h"
#include "page_time_select.h"

#include <Arduino.h>

#include "app/app_clock.h"
#include "board/board.h"
#include "app/app_key.h"
// #include "app/app_anim.h"
#include "page/page_manager.h"

#include "page/page_include.h"

static uint16_t year;
static uint16_t old;

void *page_year_set_enter(void *data)
{
    iic_setPins(PIN_SDA, PIN_SCL);
    Wire.setClock(400000);
    date = rtc.getDateTime();

    year = date.year;
    Serial.println(year);

    old = year;

    iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
    Wire.setClock(400000);

    //显示年月日时分秒

    for (int8_t i = 0; i >= (0 - 16 - 7); i--)
    {
        matrix.clear();
        matrix.drawBitmap(i, 0, &img_time[18 * 0], 16, 9, 16);

        matrix.setCursor(0 + i + 16, 5);
        matrix.setTextColor(16);
        matrix.setFont(&Org_01);
        matrix.printf("%d", year);

        delay(10);
    }

    // matrix.clear();
    // matrix.setCursor(0, 5);
    // matrix.setTextColor(16);
    // matrix.setFont(&Org_01);
    // matrix.printf("%d", hour % 12 ? hour % 12 : 12);

    // matrix.setTextColor(10);
    // matrix.setFont(&TomThumb);
    // matrix.setCursor(9, 7);
    // matrix.printf("%s", am ? "AM" : "PM");

    app_key_clean();
    manager_set_busy_state(false);
    return NULL;
}

//根据按键情况，对其进行不同操作处理
void page_year_set_loop(void *data)
{
    KEY_TYPE key = app_key_get();

    switch (key)
    {
    case KEY0_SHORT:
        year--;

        iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
        Wire.setClock(400000);

        matrix.setFont(&Org_01);

        matrix.setCursor(-7, 5);
        matrix.setTextColor(0);
        matrix.printf("%d", old);

        matrix.setTextColor(16);
        matrix.setCursor(-7, 5);
        matrix.printf("%d", year);

        old = year;

        //   manager_switch(LEVEL_PREV);
        break;
    case KEY1_SHORT:
        //   manager_switch(LEVEL_NEXT);
        year++;

        iic_setPins(PIN_SDA_IS31, PIN_SCL_IS31);
        Wire.setClock(400000);

        matrix.setFont(&Org_01);

        matrix.setCursor(-7, 5);
        matrix.setTextColor(0);
        matrix.printf("%d", old);

        matrix.setCursor(-7, 5);
        matrix.setTextColor(16);
        matrix.printf("%d", year);
        old = year;

        break;
    case KEY0_LONG:

        manager_switch(LEVEL_PARENT);
        break;
    case KEY1_LONG:
        //获取相关时间

        iic_setPins(PIN_SDA, PIN_SCL);
        Wire.setClock(400000);
        date = rtc.getDateTime();
        date.year = year;

        rtc.setDateTime(date);
        manager_switch(LEVEL_PARENT);

        break;

    default:
        break;
    }
}

void page_year_set_exit(void *data)
{

    // lv_task_del(task);
    //退出动画，进行切换
}
